<template>
    <button
        type="button"
        class="group btn"
        :class="{
            'btn-icon': icon,
            'w-full': block,
            'opacity-50': disabled || busy,
            [`${computedBtnClass}`]: true
        }"
        :disabled="disabled || busy"
        @click="onClick"
    >
        <slot />
    </button>
</template>

<script setup>
import {computed} from "vue";

const props = defineProps({
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    busy: {
        required: false,
        type: Boolean,
        default: false,
    },
    block: {
        required: false,
        type: Boolean,
        default: true,
    },
    type: {
        required: false,
        type: String,
        default: 'primary',
    },
    icon: {
        required: false,
        type: Boolean,
        default: false,
    },
    elevated: {
        required: false,
        type: Boolean,
        default: false,
    },
    rounded: {
        required: false,
        type: Boolean,
        default: true,
    },
    outline: {
        required: false,
        type: Boolean,
        default: false,
    },
    soft: {
        required: false,
        type: Boolean,
        default: false,
    }
});
const emit = defineEmits(['click']);

const onClick = () => {
    if (!props.disabled && !props.busy) emit('click');
};
const computedBtnClass = computed(() => {
    if (props.outline) {
        return `btn-outline-${props.type}`;
    } else if (props.soft) {
        return `btn-${props.type}-soft`;
    } else {
        if (props.elevated && props.rounded) {
            return `btn-elevated-rounded-${props.type}`;
        } else if (props.rounded) {
            return `btn-rounded-${props.type}`;
        } else if (props.elevated) {
            return `btn-elevated-${props.type}`;
        } else {
            return `btn-${props.type}`;
        }
    }
})
</script>
